/**************************************************************
FastViterbi.H
bmajoros@duke.edu

This is OPEN SOURCE SOFTWARE governed by the ARTISTIC LICENSE.
***************************************************************/
#ifndef INCL_FastViterbi_H
#define INCL_FastViterbi_H

#include <iostream>
#include "BOOM/Set.H"
#include "HiddenMarkovModel.H"
#include "BOOM/Sequence.H"
#include "BOOM/BitSet.H"
#include "HMMGraph.H"
#include "BOOM/Vector.H"
#include "BOOM/Array2D.H"
using namespace std;


class FastViterbi
{
public:
  FastViterbi(HiddenMarkovModel &);
  Vector<int> *getPath(Sequence &);
private:
  int numStates;
  HMMGraph hmmGraph;
  Vector<int> *buildPath(int L,int pathEndState,
			     Array2D<short> &ptr);
};


#endif
