/**************************************************************
ForwardAlgorithm.H
bmajoros@duke.edu

This is OPEN SOURCE SOFTWARE governed by the ARTISTIC LICENSE.
***************************************************************/
#ifndef INCL_ForwardAlgorithm_H
#define INCL_ForwardAlgorithm_H
#include "BOOM/Array2D.H"
#include "BOOM/Array1D.H"
#include "HiddenMarkovModel.H"

class ForwardAlgorithm
{
public:
  ForwardAlgorithm(HiddenMarkovModel &,Sequence &);
  double getLogP();
  DblArray1D &getScalingFactors();
  bool PValueExceeds(ForwardAlgorithm &);
  double operator()(int state,int pos); // uses 1-based indices...
  double getScaledP();
private:
  double P;
  Sequence &sequence;
  int numStates, seqLen;
  Array1D<double> scalingFactors;
  Array2D<double> dpMatrix;
  HiddenMarkovModel &hmm;
  void computeDPMatrix();
  double computeScalingFactor(int);
};


#endif
