/**************************************************************
HMMGraph.H
bmajoros@duke.edu

This is OPEN SOURCE SOFTWARE governed by the ARTISTIC LICENSE.
***************************************************************/

#ifndef INCL_HMMGraph_H
#define INCL_HMMGraph_H

#include "HiddenMarkovModel.H"
#include "BOOM/Vector.H"

struct StateDoublePair
{
  short state;
  double logP, P;
  StateDoublePair(int s,double logP,double P) 
    : state(s), logP(logP), P(P) {}
};

class HMMGraph
{
public:
  HMMGraph(HiddenMarkovModel &);
  Vector<StateDoublePair> &statesEmitting(Symbol);
  Vector<StateDoublePair> &statesPreceding(int state);
  Vector<StateDoublePair> &statesFollowing(int state);
  HiddenMarkovModel &getHMM();
private:
  HiddenMarkovModel &hmm;
  typedef Vector< Vector<StateDoublePair> > StateLists;
  StateLists emissions;    // symbol -> states emitting it
  StateLists predecessors; // state -> predecessors
  StateLists successors;   // state -> successors
  void init();
};


#endif
