/**************************************************************
UnscaledForwardAlgorithm.H
bmajoros@duke.edu

This is OPEN SOURCE SOFTWARE governed by the ARTISTIC LICENSE.
***************************************************************/
#ifndef INCL_ForwardAlgorithm_H
#define INCL_ForwardAlgorithm_H
#include "BOOM/Array2D.H"
#include "BOOM/Array1D.H"
#include "HiddenMarkovModel.H"

class ForwardAlgorithm
{
public:
  ForwardAlgorithm(HiddenMarkovModel &,Sequence &);
  double getP();
  double operator()(int state,int pos); // uses 1-based indices...
private:
  double P;
  Sequence &sequence;
  int numStates, seqLen;
  Array2D<double> dpMatrix;
  HiddenMarkovModel &hmm;
  void computeDPMatrix();
};


#endif
